package eu.mhsl.minenet.minigames.instance.game.stateless.types.tetris.game;

import eu.mhsl.minenet.minigames.instance.game.stateless.StatelessGame;
import eu.mhsl.minenet.minigames.util.BatchUtil;
import net.minestom.server.coordinate.Pos;
import net.minestom.server.instance.batch.AbsoluteBlockBatch;
import net.minestom.server.instance.block.Block;

public class Playfield {
    private final Pos lowerLeftCorner;

    public Playfield(Pos lowerLeftCorner) {
        this.lowerLeftCorner = lowerLeftCorner;
    }

    public Pos getPlayerSpawnPosition() {
        return lowerLeftCorner.add(6, 8, 15);
    }

    public Pos getTetrominoSpawnPosition() {
        return this.lowerLeftCorner.add(5, 21, 1);
    }

    public void generate(StatelessGame instance) {
        AbsoluteBlockBatch batch = new AbsoluteBlockBatch();

        for(int x=0; x<12; x++) {
            for(int y=0; y<21; y++) {
                batch.setBlock(lowerLeftCorner.add(x, y, 0), Block.STONE);

                if(x==0 || x==11 || y==0) {
                    batch.setBlock(lowerLeftCorner.add(x, y, 1), Block.GRAY_CONCRETE);
                }
            }
        }

        batch.setBlock(getPlayerSpawnPosition().sub(0, 1, 0), Block.STONE);

        BatchUtil.loadAndApplyBatch(batch, instance, () -> {});
    }
}
